<template>
  <el-dialog v-model="props.modelValue" title="选择用户" width="900px" @closed="closeDialog" @open="openDialog">

    <el-form inline :model="queryParams">
      <el-form-item label="用户名称">
        <el-input v-model='queryParams.userName' placeholder='请输入用户名称'></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="tableRef.reload()" icon="ElIconSearch">
          搜索
        </el-button>
      </el-form-item>
    </el-form>

    <!-- 表格渲染  prop="对应的字段"-->
    <el-table v-loading="loading" :data="usersList" ref="tableRef" border highlight-current-row
      @row-click="handleRowClick">
      <el-table-column prop="userName" label="用户名称" align="left" :show-overflow-tooltip="true" />
    </el-table>
    <pagination :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getUserListFun" />

    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="handleEditClick()">添加</el-button>
        <el-button @click="handleResetClick()">重置</el-button>
      </span>
    </template>
  </el-dialog>
</template>

<script setup>
import { reactive, ref, watch, nextTick } from 'vue';
import { ElMessage } from 'element-plus'
import { getUserWithOutBindList } from '@/api/business/ShopManager/Shops/shop.js';

// 业务参数
const total = ref(0)
const loading = ref(false)

// 基础参数
const tableRef = ref(null);
// 查询参数
const queryParams = reactive({
  userName: "",
  pageNum: 1,
  pageSize: 10
});

const emits = defineEmits(['update:modelValue']);
const props = defineProps({
  modelValue: Boolean,
  data: Object,
});
const formData = ref({
  ...props.data
});

let usersList = ref([]);
// 打开窗口时运行
const openDialog = async () => {
  await getUserListFun()
}

const getUserListFun = async () => {
  loading.value = true
  await getUserWithOutBindList(queryParams).then((res) => {
    if (res.code == 200) {
      usersList.value = res.data.result
      total.value = res.totalNum
      loading.value = false
    }
  })
}

watch(props, (v) => {
  formData.value = v.data;
});

// -业务方法
let userName = ref("");
let userId = ref("");


// -基础方法

// 点击行
const handleRowClick = (row) => {
  userName.value = row.userName
  userId.value = row.userId
}

const closeDialog = () => {
  userName.value = ""
  emits('update:modelValue', false);
};

// 提交 
const handleEditClick = async () => {
  if (userName.value !== "") {
    
    formData.value.userName = userName.value
    formData.value.shopUserId = userId.value
    if (formData.value.userName != null) {
      closeDialog();
    }
  } else {
    ElMessage.error("请选择用户")
    return;
  }
};

const handleResetClick = async formEl => {

};
</script>

